/* File: helloworldmodule.c */

#include "<Python.h>"

/* external function*/
static PyObject *sayhello(PyObject *self)
{
  return Py_BuildValue("s","Hello Python World!");
}

/* name binding table */
static PyMethodDef hellomethods[] = {
  {"say", sayhello, METH_VARARGS},
  {NULL, NULL}            /* sentinel */
};

/* initialization function*/
DL_EXPORT(void) inithello()
{
  Py_InitModule("hello", hellomethods);
}
